'# MWS Version: Version 2006.0.0 - Oct 27 2005 - 15:07:04

'# length = mm
'# frequency = GHz
'# time = ns
'# frequency range: fmin = 0 fmax = 12


'@ use template: Planar Coupler (Microstrip, Coplanar)

' Template for Planar Coupler (Microstrip or Coplanar)
' ====================================================
' (CSTxMWSxONLY)
' draw the bounding box
Plot.DrawBox True
' set units to mm, ghz
With Units 
     .Geometry "mm" 
     .Frequency "ghz" 
     .Time "ns" 
End With 
' set background material to vacuum
With Background 
     .Type "Normal" 
     .Epsilon "1.0" 
     .Mue "1.0" 
     .XminSpace "0.0" 
     .XmaxSpace "0.0" 
     .YminSpace "0.0" 
     .YmaxSpace "0.0" 
     .ZminSpace "0.0" 
     .ZmaxSpace "0.0" 
End With 
' set boundary conditions to electric
With Boundary
     .Xmin "electric" 
     .Xmax "electric" 
     .Ymin "electric" 
     .Ymax "electric" 
     .Zmin "electric" 
     .Zmax "electric" 
     .Xsymmetry "none" 
     .Ysymmetry "none" 
     .Zsymmetry "none" 
End With
' optimize mesh settings for planar structures
With Mesh 
     .MergeThinPECLayerFixpoints "True"
     .RatioLimit "50" 
     .AutomeshRefineAtPecLines "True", "4"
End With 
' change mesh adaption scheme to energy 
' 		(planar structures tend to store high energy 
'     	 locally at edges rather than globally in volume)
MeshAdaption3D.SetAdaptionStrategy "Energy"

'@ define layer: Substrat

With Layer
     .Reset 
     .Name "Substrat"
     .FrqType "hf" 
     .Type "Normal" 
     .Epsilon "2.2" 
     .Mue "1.0" 
     .Kappa "0.0" 
     .TanD "0.0" 
     .TanDFreq "0.0" 
     .TanDGiven "False" 
     .TanDModel "ConstTanD" 
     .KappaM "0.0" 
     .TanDM "0.0" 
     .TanDMFreq "0.0" 
     .TanDMGiven "False" 
     .DispModelEps "None" 
     .DispModelMue "None" 
     .Rho "0.0" 
     .Colour "1", "0.501961", "0.25098" 
     .Wireframe "False" 
     .Transparency "0" 
     .Create
End With

'@ define brick: Substrat:solid1

With Brick
     .Reset 
     .Name "solid1" 
     .Layer "Substrat" 
     .Xrange "-10", "10" 
     .Yrange "-10", "10" 
     .Zrange "0", "0.7874" 
     .Create
End With

'@ pick face

Pick.PickFaceFromId "Substrat:solid1", "1"

'@ align wcs with face

WCS.AlignWCSWithSelectedFace 
Pick.PickCenterpointFromId "Substrat:solid1", "1" 
WCS.AlignWCSWithSelectedPoint

'@ store picked point: 1

Pick.NextPickToDatabase "1" 
Pick.PickMidpointFromId "Substrat:solid1", "4"

'@ store picked point: 2

Pick.NextPickToDatabase "2" 
Pick.PickMidpointFromId "Substrat:solid1", "2"

'@ define brick: PEC:solid2

With Brick
     .Reset 
     .Name "solid2" 
     .Layer "PEC" 
     .Xrange "xp(1) - 0.5*(2)", "xp(1) + 0.5*(2)" 
     .Yrange "yp(1)", "yp(2)" 
     .Zrange "0", "0.1" 
     .Create
End With

'@ pick face

Pick.PickFaceFromId "Substrat:solid1", "2"

'@ align wcs with face

WCS.AlignWCSWithSelectedFace 
Pick.PickCenterpointFromId "Substrat:solid1", "2" 
WCS.AlignWCSWithSelectedPoint

'@ pick face

Pick.PickFaceFromId "Substrat:solid1", "2"

'@ define extrude: PEC:solid3

With Extrude 
     .Reset 
     .Name "solid3" 
     .Layer "PEC" 
     .Mode "Picks" 
     .Height "0.1" 
     .Twist "0.0" 
     .Taper "0.0" 
     .UsePicksForHeight "False" 
     .DeleteBaseFaceSolid "False" 
     .ClearPickedFace "True" 
     .Create 
End With

'@ store picked point: 3

Pick.NextPickToDatabase "3" 
Pick.PickCenterpointFromId "PEC:solid3", "5"

'@ snap point to drawplane

Pick.SnapLastPointToDrawplane

'@ store picked point: 4

Pick.NextPickToDatabase "4" 
Pick.PickCenterpointFromId "PEC:solid3", "5"

'@ snap point to drawplane

Pick.SnapLastPointToDrawplane

'@ store picked point: 5

Pick.NextPickToDatabase "5" 
Pick.PickEndpointFromId "PEC:solid3", "4"

'@ snap point to drawplane

Pick.SnapLastPointToDrawplane

'@ store picked point: 6

Pick.NextPickToDatabase "6" 
Pick.PickCenterpointFromId "PEC:solid3", "5"

'@ define brick: PEC:solid4

With Brick
     .Reset 
     .Name "solid4" 
     .Layer "PEC" 
     .Xrange "-6.2", "6.2" 
     .Yrange "- 0.5*(0.5)", "0.5*(0.5)" 
     .Zrange "0", "zp(6)" 
     .Create
End With

'@ boolean subtract shapes: PEC:solid3, PEC:solid4

Solid.Subtract "PEC:solid3", "PEC:solid4"

'@ pick mid point

Pick.PickMidpointFromId "PEC:solid3", "28"

'@ align wcs with point

WCS.AlignWCSWithSelectedPoint

'@ store picked point: 7

Pick.NextPickToDatabase "7" 
Pick.PickCenterpointFromId "PEC:solid3", "11"

'@ define brick: PEC:solid4

With Brick
     .Reset 
     .Name "solid4" 
     .Layer "PEC" 
     .Xrange "0", "5" 
     .Yrange "0 - 0.5*(5)", "0 + 0.5*(5)" 
     .Zrange "0", "zp(7)" 
     .Create
End With

'@ activate global coordinates

WCS.ActivateWCS "global"

'@ transform: mirror PEC:solid4

With Transform 
     .Reset 
     .Name "PEC:solid4" 
     .Origin "Free" 
     .Center "0", "0", "0" 
     .PlaneNormal "1", "0", "0" 
     .MultipleObjects "True" 
     .GroupObjects "True" 
     .Repetitions "1" 
     .MirrorAdvanced 
End With

'@ boolean subtract shapes: PEC:solid3, PEC:solid4

Solid.Subtract "PEC:solid3", "PEC:solid4"

'@ define automesh state

Mesh.Automesh "True"

'@ define frequency range

Solver.FrequencyRange "0", "12"

'@ define boundaries

With Boundary
     .Xmin "magnetic"
     .Xmax "magnetic"
     .Ymin "magnetic"
     .Ymax "magnetic"
     .Zmin "magnetic"
     .Zmax "magnetic"
     .Xsymmetry "magnetic" 
     .Ysymmetry "none" 
     .Zsymmetry "none" 
     .WallConductivity "1000" 
End With

'@ define background

With Background 
     .Type "Normal" 
     .Epsilon "1.0" 
     .Mue "1.0" 
     .XminSpace "0.0" 
     .XmaxSpace "0.0" 
     .YminSpace "0.0" 
     .YmaxSpace "0.0" 
     .ZminSpace "3" 
     .ZmaxSpace "5" 
End With

'@ pick face

Pick.PickFaceFromId "Substrat:solid1", "3"

'@ define port: 1

With Port 
     .Reset 
     .PortNumber "1" 
     .NumberOfModes "1" 
     .AdjustPolarization False 
     .PolarizationAngle "0.0" 
     .ReferencePlaneDistance "0" 
     .TextSize "50" 
     .Coordinates "Free" 
     .Location "ymin" 
     .Xrange "-10", "10" 
     .Zrange "-3.1", "5.8874" 
     .Create 
End With

'@ pick face

Pick.PickFaceFromId "Substrat:solid1", "5"

'@ define port: 2

With Port 
     .Reset 
     .PortNumber "2" 
     .NumberOfModes "1" 
     .AdjustPolarization False 
     .PolarizationAngle "0.0" 
     .ReferencePlaneDistance "0" 
     .TextSize "50" 
     .Coordinates "Free" 
     .Location "ymax" 
     .Xrange "-10", "10" 
     .Zrange "-3.1", "5.8874" 
     .Create 
End With

'@ define monitor: e-field (f=5)

With Monitor 
     .Reset 
     .Name "e-field (f=5)" 
     .Dimension "Volume" 
     .Domain "Frequency" 
     .FieldType "Efield" 
     .Frequency "5" 
     .Create 
End With

'@ define solver parameters

With Solver 
     .CalculationType "TD-S" 
     .StimulationPort "All" 
     .StimulationMode "All" 
     .SteadyStateLimit "-50" 
     .MeshAdaption "False" 
     .AutoNormImpedance "False" 
     .NormingImpedance "50" 
     .CalculateModesOnly "False" 
     .SParaSymmetry "False" 
     .StoreTDResultsInCache "False" 
     .FullDeembedding "False" 
     .UseNetworkComputing "False" 
End With 

